function r = check_grid ()
    global IM;
    global IM_marked;
    global Default_board_size;
    global Default_pixel_size;
    global projections;
    global black_color_data;
    global white_color_data;
    global grid;
    global image_handle;
    global default_random_samples;

    % result 
    r = zeros (8,8);

    debug = 1;

    % normalize image color
    tmp = 1/(white_color_data-black_color_data);
    IM=(IM-black_color_data)*tmp;
    
%     color_mask = zeros(size (IM,1), size (IM,2));

    % go over all the tiles and collect random pixels for evaluation
    for i = 1:length (grid)
        % find pixel position in one channel
        index = size(IM,1)*(projections{i}(:,1)-1)+projections{i}(:,2);

        % separate color channels
        sourceR = IM(:,:,1);
        sourceG = IM(:,:,2);
        sourceB = IM(:,:,3);

        % color_hold all collected data
        color_data = [sourceR(index), sourceG(index), sourceB(index)];
        % reduce it to form hi/lo
        tmp_reduced = color_reduction (color_data);

        tmp_sum = sum (tmp_reduced,2);

        % if the sum is 0 or 3 then we have black and white, then locate
        % black and white pixels
        tmp_index = find (tmp_sum==3 | tmp_sum==0);

        if length(tmp_index)>round (0.7*length (index))
            % majority of the tile's area is black or white so skip this tile
            continue;
        end

        % find colored pixels
        tmp_index = find (tmp_sum~=3 & tmp_sum~=0);

        reduced_color = color_reduction (sum(color_data(tmp_index,:))/length(tmp_index));

        % determine tile's position inside of the board
        tmp_col = mod (i-1, 8)+1;
        tmp_row = floor ((i-1)/8)+1;
        if reduced_color(1)==0 && reduced_color(2)==0 && reduced_color(3)==1
            % blue
            r(tmp_row, tmp_col) = 2;
        else
            % yellow
            r(tmp_row, tmp_col) = 1;
        end

        if debug == 1
            mark_tile (i, [1, 0, 0]);
        end
    end
    
    % display the image
end