function checkers_gui ()
    warning off all;

    Nrow = 8;
    Ncol = 8;
    global Default_board_size;
    global Default_pixel_size;
    global IM;
    global IM_marked;
    global default_random_samples;
    global N_subdivisions;
    global projections;
    global black_color_data;
    global white_color_data;
    global H;
    global grid;
    global image_handle;
    

    %global old_board;
    old_board=0;
    Nsamples = 25;
    tmp_index = 1;
    Default_board_size = 8;
    grid = {};
    Default_pixel_size = 50;
    IM = 0;
    tmp_border = 5;
    N_subdivisions = 1;
    default_random_samples = tmp_border+rand(Nsamples,2)*((Default_pixel_size/N_subdivisions)-2*tmp_border);
    projections = {};
    H = 0;
    grid = {};
    
    tmprow = (Nrow)/2;
    tmpcol = (Ncol)/2;

    calib_pts = 0;
    
    tile_size = 50;%px    
    
    fg = figure ('MenuBar', 'none',...
        'Name', 'Camera calibration', ...
        'NumberTitle', 'off', ...
        'ToolBar', 'none',...
        'DockControls', 'off');
    tmp_pos = get (fg, 'Position');

    tmp_pos (3) = 640 + 20;
    tmp_pos (4) = 480 + 20;

    set (fg, 'Position', tmp_pos);
    set (fg, 'KeyPressFcn', @key_callback);

    
    
    axes_handle = axes('Parent',fg, ...
           'Units', 'pixels',...
           'HitTest', 'off',...
           'Position',[10 10 640 480]);    

    img_handle = 0;
    
    set(fg,'DeleteFcn',@stop_callback);
    vid = videoinput('winvideo', 1,'I420_640x480');
%     IMAQHWINFO(vid)
    set(vid,'FramesPerTrigger',1);
    set(vid,'TriggerRepeat',Inf);
    triggerconfig(vid, 'Manual');
    start(vid);

    scrsz = get(0, 'ScreenSize');

    while 1
        trigger(vid); 
%         try
            IM = double(ycbcr2rgb(getdata(vid,1,'uint8')))/255.0;
            IM_marked = IM;
            if size(H,1)~=3
                calib_pts = auto_cb (IM);
%                 img_handle = imshow(IM, 2);
%                 set(img_handle,'ButtonDownFcn', @buton_down_callback);
%                 IM_marked = zeros (size (IM,1), size (IM,2), size (IM,3));
            end
            if size(H,1)==3
                board = check_grid();
                img_handle = imshow(IM_marked, 2);

            end
%         catch 
            % do nothing
            %disp ('dieeeeeee');
%         end
    end
    function buton_down_callback (hObject, eventdata)
        
        % collect fort corner points
%         tmp = [];
%         for i=1:4
%             [x, y, b] = ginput(1);
%             tmp(i,1:2)=[x,y];
%         end

        % this is the ideal grid
        ptsI = [0, 0; 0, Nrow; Ncol, Nrow; Ncol, 0];
        ptsI = ptsI*tile_size;

        % calculate the homography
        H = calcH (ptsI,calib_pts);
        tmp_index = 1;

        % generate the data for all tiles: it's position inside of the image
        % and the positions of random points within it
        for y = 1:Default_board_size
            for x = 1:Default_board_size
                for sub_y = 1:N_subdivisions
                    for sub_x = 1:N_subdivisions
                        left = (x-1)*Default_pixel_size+(sub_x-1)*Default_pixel_size/N_subdivisions;
                        right = (x-1)*Default_pixel_size+(sub_x)*Default_pixel_size/N_subdivisions;
                        bottom = (y-1)*Default_pixel_size+(sub_y-1)*Default_pixel_size/N_subdivisions;
                        top = (y-1)*Default_pixel_size+(sub_y)*Default_pixel_size/N_subdivisions;

                        random_samples=default_random_samples;
                        random_samples(:,1) = random_samples(:,1) + left;
                        random_samples(:,2) = random_samples(:,2) + bottom;

                        random_samples(:,3) = 1;
                        projections{tmp_index} = round (hom(H*random_samples'));
                        tmp = [left top; right top; right bottom; left bottom];
                        tmp (:,3) = 1;
                        tmpH = hom(H*tmp');

                        grid{tmp_index} = tmpH;

                        tmp_index=tmp_index+1;
                    end
                end
            end
        end
        
        % now that we know where the tiles are we can do the color
        % normalisation
        [black_color_data, white_color_data] = do_image_normalization;
        
    end
    
    function stop_callback (hObject, eventdata)
        % stop callback function: just close the framgraber
        stop(vid);
        close;
    end
    function key_callback (hObject, eventdata)
        % key down callback function: check if the user presses space bar,
        % and then change the player's turn and start the engine
        if sum(eventdata.Key=='space')==5
            if size(H,1)~=3
                buton_down_callback (hObject, eventdata);
            else
                [numberOfJumps, initialPosition, finalPosition, path, capturedPieaces] = check_move(board, old_board);
                img_handle = imshow(IM_marked, 2);

                initialPosition
                finalPosition
            end
        end
    end
end