#include <iostream>
#include <windows.h>
#include <fstream>
#include "KestoG.h"
#include "engineWrap.h"




int IsMoveValid(int b[8][8], int color, int from, int to)
{
    HINSTANCE hGetProcIDDLL = LoadLibrary("KestoG.dll");
    FARPROC lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"islegal"); 
    typedef int (__stdcall * pICFUNC)(int [8][8], int, int, int, struct CBmove*);
    pICFUNC islegal; 
    islegal = pICFUNC(lpfnGetProcessID); 
    CBmove *cb = new CBmove;
    int x = islegal (b, color, from, to, cb);
    FreeLibrary(hGetProcIDDLL); 
    return x;    
}

int ComputeMove(int b[8][8], int color)
{
    HINSTANCE hGetProcIDDLL = LoadLibrary("KestoG.dll"); //load engine dll and construct function
    FARPROC lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"getmove"); 
    typedef int (__stdcall * pICFUNC)(int [8][8], int, double, char [1024], int *, int, int, struct CBmove*);
    pICFUNC getmove; 
    getmove = pICFUNC(lpfnGetProcessID); 

    double maxtime = 0.5; //maximal computation time
    char str[1024];       //status string (not used)
    int playNow = 0;      //play now
    int info = 0;         //info from engine
    int tmp;              //not used
    CBmove *move = new CBmove;
    std::cout<<"Solving..."<<std::endl;
    int x = getmove (b, color, maxtime, str, &playNow, info, tmp, move); //call engine to compute move
    int aa=0;
    FreeLibrary(hGetProcIDDLL);  //release engine library
    std::cout<<"End..."<<std::endl;
    
    std::ofstream off;
    off.open("engine.out");        //open output file
    
    off<<move->jumps<<std::endl;   //write number of jumps CPU did
    off<<move->newpiece<<std::endl;//status of piece after the move
    off<<move->oldpiece<<std::endl;//status of piece before the move
    off<<move->from.x<<" "<<move->from.y<<std::endl;        //initial position of the piece
    off<<move->to.x<<" "<<move->to.y<<std::endl;            //final position of the piece  
    for (int i = 0; i < 12; i ++)
        off<<move->path[i].x<<" "<<move->path[i].y<<std::endl;      //path steps
    for (int i = 0; i < 12; i ++)
        off<<move->del[i].x<<" "<<move->del[i].y<<std::endl;        //captured pieces
    for (int i = 0; i < 12; i ++)
        off<<move->delpiece[i]<<" ";                                //captured piece status
    off<<std::endl;
    for (int i = 0; i < 8; i ++)
     {
        for (int j = 0; j < 8; j ++)
            off << b[i][j]<<" ";       //new status of the board
        off<<std::endl;
    }
    return x;
}
