function mark_tile (row, col, color)
    global grid;
    global IM;
    global IM_marked;

    % mark specified tile with specified color using alphablending
    alpha = 0.5;
    color_mask = zeros(size (IM, 1), size (IM, 2));
    
    if nargin < 3    
        i = row;
        color = col;
    else
        i = col + (row-1)*8;
    end

    % get all the chanels from already marked image
    sourceR = IM_marked(:,:,1);
    sourceG = IM_marked(:,:,2);
    sourceB = IM_marked(:,:,3);
    
    % generate polygonal mask
    bw = poly2mask(grid{i}(:,1),grid{i}(:,2),size(IM,1),size(IM,2));                        
    color_mask = color_mask | bw;
    
    % make the color version of polygonal mask
    color_image(:,:,1) = color_mask*color(1)*(1-alpha);
    color_image(:,:,2) = color_mask*color(2)*(1-alpha);
    color_image(:,:,3) = color_mask*color(3)*(1-alpha);
    
    tmp_index = find(color_mask>0);

    % reduce rgb values of all pixels inside of the specified tile
    sourceR (tmp_index) = sourceR (tmp_index) * alpha;
    sourceG (tmp_index) = sourceG (tmp_index) * alpha;
    sourceB (tmp_index) = sourceB (tmp_index) * alpha;

    % combine the image and the polygonal mask
    IM_marked(:,:,1) = sourceR + color_image(:,:,1);
    IM_marked(:,:,2) = sourceG + color_image(:,:,2);
    IM_marked(:,:,3) = sourceB + color_image(:,:,3);
end