nBlocks = 50;

%
% function realTimeMic(duration, nBlocks, useVideo)
%
% This function records: 
%  - audio data from soundcard's input and 
%  - video data from webcam input
%
% In particular, 'nBlocks' of audio segments of size 'duration' are
% recorded and an image is taken every 'duration' seconds.
%
% %%%%%%%%%% %
% ARGUMENTS: %
% %%%%%%%%%% %
% nBlocks:   number of blocks to be recorded
% 

warning off;

% OPEN VIDEO INPUT:
vid = videoinput('winvideo', 1,'I420_640x480');
set(vid,'FramesPerTrigger',1);
set(vid,'TriggerRepeat',Inf);
triggerconfig(vid, 'Manual');
start(vid);

scrsz = get(0, 'ScreenSize');
%figure('Position', [1 scrsz(4) scrsz(3) scrsz(4)]);
W = 25;
F = figure;
set(F,'Position', [W 0 scrsz(3)-W scrsz(4)-3*W]);

Differences = zeros(nBlocks,1);

first = true;
for (i=1:nBlocks)
    trigger(vid); 
    
    
    IM = (getdata(vid,1,'uint8'));
    %save the first pic
    if(first)
        IM_START = rgb2gray(IM);
        first = false;
    end;
    
    IMGray = rgb2gray(IM);

    if (i==1)
        IM_PREV = IMGray; 
    end % previous video frame

%     subplot(1,3,1);
    imshow(IM, 'Parent', axes_handle);
%     title('Current Frame')

%     IM_DIFF = abs(double(IMGray) - double(IM_START)); % differnce between current and start pic
%     IM_DIFF = abs(double(IMGray) - double(IM_PREV)); % difference between current and previous 
%     subplot(1,3,2);imshow(IM_DIFF / 128); title('Motion');

    
%     IM_PREV = IMGray; % keep previous frame
    
    % find the end of the moving oject
%     border = 4*size(IM)-4;
%     for i = 1 : border
%         if()
%     end
end
% imwrite (IM, 'chboard1.png');
stop(vid);
close;
