function rez = undistort(I, H, new_size)
    if nargin<3
        new_size = size(I);
    end
    
    rez = zeros (new_size(1)+1, new_size(2)+1, 3);
    
    for y=1:new_size(1)+1
        for x=1:new_size(2)+1
            tmph = H*[x y 1]';
            tmph=tmph/tmph(3);

            tx = tmph(1);
            ty = tmph(2);
            
            xcordF = floor (tx);
            ycordF = floor (ty);

            X = tx-xcordF;
            Y = ty-ycordF;
            A = (1-X)*(1-Y);
            B = X*(1-Y);
            C = X*Y;
            D = (1-X)*Y;
            try 
                rez (y, x, :) = A*I(ycordF, xcordF, :)+B*I(ycordF, xcordF+1, :)+C*I(ycordF+1, xcordF+1, :)+D*I(ycordF+1, xcordF, :);
            catch
                % dropped out of the image
            end
            
        end
    end

end